/*
Copyright ESIEE (2009) 

m.couprie@esiee.fr

This software is an image processing library whose purpose is to be
used primarily for research and teaching.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software. You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

/* authors : J. Cousty - L. Najman and M. Couprie */


#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdint.h>

#include <math.h>
#include <string.h>
#include <float.h>
//#include <mccodimage.h>
//#include <mcimage.h>
//#include <mcweightgraph.h>
#include <sjimage2graph.h>

#define mcabs(X) ((X)>=0?(X):-(X))
#define mcmax(X,Y) ((X)>=(Y)?(X):(Y))
#define mcmin(X,Y) ((X)<=(Y)?(X):(Y))
#define mcodd(X) ((X)&1)
#define mceven(X) (((X)&1)==0)
#define mcsqr(x) ((x)*(x))


void usage(char *arg){
  printf("#################################################################\n\n");
  printf("USAGE: %s IN.pgm mode OUT.graph \n",arg); 	
  printf("#################################################################\n\n");
}

int32_t main(int32_t argc, char* argv[])
{	
  struct xvimage * r;
  struct xvimage * v;
  struct xvimage * b;
  int32_t param;
  double *Fv;
  graphe *g;

  if ( (argc != 4) && (argc != 5))
  {
    fprintf(stderr, "usage: %s im.pgm param  out.ppm \nparam = 0 max (sur RGB) des differences entre pixel extremite, param = 1 distance euclidienne entre pixels extremit�s, param = 2 affinit� floue.\n", 
    argv[0]);
    exit(1);
  }
  if ( readrgbimage(argv[1], &r,&v,&b) == 0 )
  {
    fprintf(stderr, "%s: ne peut lire %s \n", argv[0], argv[1]);
    exit(1);
  }
   param = atoi(argv[2]);

   if( sjppm2graph(r,v,b,param,&g,&Fv) != 1 )
      {
	fprintf(stderr, "%s: erreur de lppm2ga \n", argv[0]);
	exit(1);
      }
    SaveGraphe(g, argv[3], Fv);
    terminegraphe(g);
	free(Fv);

  freeimage(r); freeimage(v); freeimage(b);
  return 0;

  return 0;

}
