#!/bin/bash


tmpFile1=`mktemp`
tmpFile2=`mktemp`

if [$# -ne 3]; then 
    echo "Usage: $0 <input.ppm> <output.gaph>"
    exit 1
fi
./SEDGradient.sh $1 $tmpFile1 \
&& ../WatershedsGenericAndTools/linux/bin/gradient2graph $tmpFile1 0 $tmpFile2 \
&& ../WatershedsGenericAndTools/linux/bin/extinctionvalues $tmpFile2 3 $tmpFile1  \
&& ../WatershedsGenericAndTools/linux/bin/uprooting $tmpFile1 $tmpFile2 \
&& ../WatershedsGenericAndTools/linux/bin/ultramopen $tmpFile2 $1 \
&& ../WatershedsGenericAndTools/linux/bin/areaFilter $tmpFile2 0.0008 $2 
res=$?
rm $tmpFile1 $tmpFile2
exit $res
